/**
 * Concrete non-empty list structure containing an int, called first,
 * and a rest, which is a list structure.
 */
public class ConsIntList extends IntList {
  
    private int first;
    private IntList rest;

    public ConsIntList(int first, IntList rest) {
      this.first = first;
      this.rest = rest;
    }

    public int getFirst() {
      return first;
    }
    
    public IntList getRest() {
      return rest;
    }
    
    public Object accept(IntListVisitor v) {
        return v.forConsIntList(this);
    }
    
    /**
     * Alternate visitor impelementation using separate input parameters
     * @param v The visitor to run.  Must be of the type that takes a separate input parameter
     * @param params Variable argurment list that allows 0...n input parameters of type Object
     * @return The result from running the visitor
     */
    public Object acceptSW(IntListVisitorSW v, Object... params) {
        return v.forConsIntList(this, params);
    }
}