/**
 * Concrete empty list structure containing nothing.
 */
public class EmptyIntList extends IntList {
  public static final EmptyIntList ONLY = new EmptyIntList();
  
  private EmptyIntList() {}
  
  public Object accept(IntListVisitor v) {
        return v.forEmptyIntList(this);
    }
  
      /**
     * Alternate visitor impelementation using separate input parameters
     * @param v The visitor to run.  Must be of the type that takes a separate input parameter
     * @param params Variable argurment list that allows 0...n input parameters of type Object
     * @return The result from running the visitor
     */
    public Object acceptSW(IntListVisitorSW v, Object... params) {
        return v.forEmptyIntList(this, params);
    }
}

