/**
 * Abstract list structure.
 */
public abstract class IntList {
  
  public abstract Object accept(IntListVisitor v);
  
  
  
  /**
   * Alternate visitor impelementation using separate input parameters
   * @param v The visitor to run.  Must be of the type that takes a separate input parameter
   * @param params Variable argurment list that allows 0...n input parameters of type Object
   * @return The result from running the visitor
   */
  public abstract Object acceptSW(IntListVisitorSW v, Object... params);
  
  
  public ConsIntList cons(int n) {
    return new ConsIntList(n, this);
  }
}

