/**
 * Alternate implemenation
 * Forward accumulation of the sum of elements in a list
 */
public class SumVisitorSW implements IntListVisitorSW {
  public static final SumVisitorSW ONLY = new SumVisitorSW();
  
  private SumVisitorSW() {}
  /**
   * input parameters "not used" ("nu")
   */
  public Object forEmptyIntList(EmptyIntList host, Object...nu) {
    return 0;
  }
  
  /**
   * input parameters "not used" ("nu")
   */
  public Object forConsIntList(ConsIntList host, Object... nu) {
    // Delegate to a helper visitor
    return host.getRest().acceptSW(new IntListVisitorSW() {

      /**
       * @param params params[0] is the accumulator
       */
      public Object forEmptyIntList(EmptyIntList hostHelper, Object... params) {
        return params[0];
      }
      
      /**
       * @param params params[0] is the accumulator
       */
      public Object forConsIntList(final ConsIntList hostHelper, Object... params) {

        return hostHelper.getRest().acceptSW(this,  hostHelper.getFirst()+((Integer)params[0]));
      }
      
    }, host.getFirst()); // Supply the initial value of the accumulator as the input parameter to the helper
  } 
}